Subject: Re: bug#54043: Simple regexp bug [contains spoiler for today's wordle]
From: Jim Meyering <[email-masked]>
To: Matthew Wilcox <[email-masked]>
Cc: [email-masked]
Date: Thu, 17 Feb 2022 08:13:54 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

On Thu, Feb 17, 2022 at 7:46 AM Matthew Wilcox <[email-masked]> wrote:
> I noticed this one while doing:
>
> $ grep sha[^s]e five-letter-words
> share
>
> which doesn't fit with:
>
> $ grep sha.e five-letter-words
> shade
> shake
> shale
> shame
> shape
> share
> shave
>
> A reproducer is easy:
>
> $ echo shame |grep sha[^s]e
> (no output)

This is not a bug in grep. Your failure to quote the regular expression
means that the argument is first interpreted by the shell.
To demonstrate the argument that "grep" ends up using,
run this from that same directory:

  echo sha[^s]e

If I have something named e.g., "shape" in the current directory, that
would print "shape". If I have two matching names, e.g., shave and shale,
it will print both names.

IMHO, it is almost always best to single-quote regular expressions like that.
Quoting your reproducer, you see it works as desired:

  $ echo shame |grep 'sha[^s]e'
  shame